Description

If you visit a mapped domain as a logged in user, under the subdomain URL - eg https://newlaborforum.commons.gc.cuny.edu/ -
some assets don't load properly because of SSL issues. For example, the header image in the attached screenshot tries to load from
https://newlaborforum.cuny.edu..., which is not available under SSL. | assume this is because of some is_ssl() checks, either in the
theme or in core functions like wp_get_attachment_url().

Ray, could | ask you to have a look to see if there's a quick fix or workaround? It's not worth a ton of effort, since (a) these pages will
rarely be seen like this (only admins will see it) and (b) it's likely we'll have SSL for these sites in the short to medium term because
of Lihua's letsencrypt work. But if there's something relatively easy we can do - eg in the SSL functions in
wp-content/mu-plugins/cac-functions.php - it may be worth looking at.

Related issues:
Related to CUNY Academic Commons - Bug #9828: redirecting problem Resolved 2018-05-24

History

#1 - 2018-05-08 10:46 AM - Boone Gorges
- File Screenshot_2018-05-08_14-45-53.png added

#2 - 2018-05-08 01:43 PM - Raymond Hoh
Ugh, good catch.

The problem is the customizer functionality of WordPress saves the absolute URL of the theme assets from the current URL. Because the original
customizer changes were made on the mapped domain, those theme asset URLs are now using the mapped domain instead of the subdomain.

The following snippet fixes this for the various customizer options requiring attachments:

function cac_set_mapped_url_to_subdomain( Surl ) {
global Swpdb;

// bail if we're on a mapped domain
if ( cac_is_domain_mapping_enabled_for_current_blog() ) {
return Surl;

}

// Check if the currnet blog has a mapped domain...
$Sdomain = $wpdb->get_var( "SELECT domain FROM {S$wpdb->dmtable} WHERE blog_id = '{$wpdb->blogid}' AND activ
e = 1 LIMIT 1" );
if ( empty( $domain ) ) {
return $url;

}

Surl str_replace( '://' . $domain, '://' . $GLOBALS['current_blog']->domain, S$url );
Surl = set_url_scheme( $url, is_ssl() ? 'https' : 'http' );

return $url;

}

add_filter( 'theme_mod_header_image', 'cac_set_mapped_url_to_subdomain' );
add_filter( 'theme_mod_header_video', 'cac_set_mapped_url_to_subdomain' );
add_filter( 'theme_mod_background_image', 'cac_set_mapped_url_to_subdomain' );
add_filter( 'theme_mod_custom_logo', 'cac_set_mapped_url_to_subdomain' );

But, it uses an uncached DB query because the WPMU Domain Mapping plugin does not cache this info from their DB table.

Since there are way more non-mapped domains, do we want to write a caching layer for WPMU Domain Mapping so we can then apply this snippet?
#3 - 2018-05-08 02:02 PM - Boone Gorges

Yeah, I'd say it's worth it to write that layer. It'd benefit us elsewhere. Thanks!

#4 - 2018-05-14 05:13 PM - Raymond Hoh
Boone Gorges wrote:
Yeah, I'd say it's worth it to write that layer. It'd benefit us elsewhere. Thanks!

I've written an object cache layer for wordpress-mu-domain-mapping in a separate branch for our cac repo:
https://github.com/cuny-academic-commons/cac/compare/1.13.x...dm-object-cache

Let me know what you think.

#5 - 2018-05-17 01:49 PM - Boone Gorges

This looks good to me, Ray. A couple non-critical questions:

- Do you think there's a reason why the plugin authors haven't added caching for this in the past? It seems an obvious win. Maybe there's problems in
multi-server environments or something? Would it make sense to package this as a PR/patch for the plugin?

- Is there benefit (maybe not direct to this ticket, but in general) to adding caching in the other direction as well? le blog ID lookup given a domain - the
query that takes place in sunrise.php. (I think the cache system is booted by this point?)

I'd say you're good to update https:/redmine.gc.cuny.edu/issues/9735#note-2 in light of the new cached function, and add it to the codebase for
1.13.2.

#6 - 2018-05-17 05:15 PM - Raymond Hoh

Would it make sense to package this as a PR/patch for the plugin?
I couldn't find a Git repo for the wordpress-mu-domain-mapping plugin anywhere. There are some forks on Github though. Could post the patch on
the wp.org support forums and hope for the best.
le blog ID lookup given a domain - the query that takes place in sunrise.php. (I think the cache system is booted by this point?)
Good spot about sunrise.php. | can look into adding caching by domain later down the road, but as you mention, it's not critical for this ticket. We
would also have to move some other code into sunrise.php like the wp_cache_add_global_groups( 'wpmu_dm'); call.
For now, I'll merge what | have into 1.13.x branch and add the code | wrote to address this specific ticket.
Thanks for the feedback!
#7 - 2018-05-21 06:24 PM - Raymond Hoh
- Status changed from New to Staged for Production Release
I've merged the dm-object-cache branch in https://github.com/cuny-academic-commons/cac/commit/3211d0aaailf7b6adc497a5b3f89b46c7e1dcd204

And I've added the fix referenced above in https://github.com/cuny-academic-commons/cac/commit/93abbffbc28237820783a088908fbb088b779fd0.

As for reaching out to the plugin authors, I've posted a thread in the wp.org support forums here with a link to the patch.

#8 - 2018-05-22 10:20 AM - Boone Gorges

Thanks! Going to mark resolved in advance of the release.

#9 - 2018-05-22 10:56 AM - Boone Gorges

- Status changed from Staged for Production Release to Resolved

#10 - 2018-05-24 02:53 PM - Raymond Hoh
- Related to Bug #9828: redirecting problem added
